//+--------------------------------------------------------------------------------------+
//|                                           Fourier Extrapolation of Indicator 1.1.mq4 |
//|                                                               Copyright  2008, gpwr |
//| mod STS 2010                                                      vlad1004@yahoo.com |
//+--------------------------------------------------------------------------------------+

///added color ,var ShowBaseIndi,alerts with line and arrows functions by leledc
///changed Indi's to "Ehlers Two Pole Super Smoother Filter" and "McGinley Dynamic main" by STS
#property copyright "Copyright  2009, gpwr"
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_color2 CLR_NONE
#property indicator_color3 DarkOrange
#property indicator_color4 Blue
#property indicator_color5 Maroon
#property indicator_width1 1
#property indicator_width2 0
#property indicator_width3 1
#property indicator_width4 3
#property indicator_width5 3
//Global constants
#define pi 3.141592653589793238462643383279502884197169399375105820974944592
#define BUY 1
#define SELL -1
bool TurnedUp = false;
bool TurnedDown = false;

//Input parameters
extern string Comment1="Put the name of indi here exactly as shown below";
extern string Comment2="Ehlers,McGinley";
extern string IndiName="Ehlers";
extern string Comment3="Indicator Settings";
extern int Period_Indi=12;
extern int McGinley_Price=6;
extern string Comment4="FFT Settings";
extern int LastBar = 0;  //Last bar in the past data
extern int PastBars = 300;  //Number of past bars
extern int FutBars = 30;  //Number of bars to predict 
extern int HarmNo = 30;  //Number of frequencies; HarmNo=0 computes PastBars harmonics
extern double FreqTOL = 0.0001;  //Tolerance of frequency calculation
extern bool ShowBaseIndi=false;
extern string Comment5="Alert Options";
extern bool Draw_Line=true;
extern int WidthLine=3;
extern bool Draw_Arrow=false;
extern int WidthArrow=2;
extern int ArrowUp=233;
extern int ArrowDown=234;
extern color colorup=MediumSeaGreen;
extern color colordown=Salmon;
extern bool AlertOn=false;
extern int distance=5;

extern bool Five_digit_broker=true;

int count,trend,LastSignal;
#define SignalName "FFT"

//Indicator buffers
double in[];
double pv[];
double fv[];
double FFT_Up[];
double FFT_Down[];

//Global variables
int np,nf,lb;
string shortname;
int DistanceUp,DistanceDown;

int init()
{
DeleteObjects();

   lb=LastBar;
   np=PastBars;
   nf=FutBars;
   if(HarmNo==0 || HarmNo>np) HarmNo=np;
   
   IndicatorBuffers(5);
   SetIndexBuffer(0,in);
   SetIndexBuffer(1,pv);
   SetIndexBuffer(2,fv);
   SetIndexBuffer(3,FFT_Up);
   SetIndexBuffer(4,FFT_Down);
  if( ShowBaseIndi){
   SetIndexStyle(0,DRAW_LINE);
   }else
   {
    SetIndexStyle(0,DRAW_NONE);
   }
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexShift(1,-lb);//past data vector 0..np-1; 0 corresponds to bar=lb
   SetIndexShift(2,nf-lb);//future data vector i=0..nf; nf corresponds to bar=lb
   SetIndexShift(3,-lb);
    SetIndexShift(4,-lb);
       IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

   return(0);
}

int deinit(){
DeleteObjects();

return(0);}

int start()
{
DeleteObjects();

int limit,limit2;

int counted_bars = IndicatorCounted();
if(counted_bars > 0) 
counted_bars--;
limit = Bars - counted_bars; 
if (limit2 < PastBars ) 
limit = PastBars;
if (Five_digit_broker==true){
DistanceUp=distance*10;
if (Period()==PERIOD_M15){
DistanceDown=((distance+5)*10);
}
else if (Period()==PERIOD_M30 ){
DistanceDown=((distance+10)*10);
}
else if (Period()==PERIOD_H1 ){
DistanceDown=((distance+13)*10);
}
else if(Period()==PERIOD_H4 ){
DistanceDown=((distance+32)*10);
}
else if (Period()==PERIOD_D1){
DistanceDown=((distance+50)*10);
}
else if (Period()==PERIOD_W1){
DistanceDown=((distance+200)*10);
}
else if(Period()==PERIOD_MN1){
DistanceDown=((distance+400)*10);
}
else 
{
DistanceDown=((distance+5)*10);
}
 }
else if (Five_digit_broker==false){
DistanceUp=distance;
 if (Period()==PERIOD_M15){
DistanceDown=((distance+5));
}
else if (Period()==PERIOD_M30 ){
DistanceDown=((distance+10));
}
else if (Period()==PERIOD_H1 ){
DistanceDown=((distance+13));
}
else if(Period()==PERIOD_H4 ){
DistanceDown=((distance+32));
}
else if (Period()==PERIOD_D1){
DistanceDown=((distance+50));
}
else if (Period()==PERIOD_W1){
DistanceDown=((distance+200));
}
else if(Period()==PERIOD_MN1){
DistanceDown=((distance+400));
}
else 
{
DistanceDown=(distance+3);
}
} 
  ArrayInitialize(in,EMPTY_VALUE);
  ArrayInitialize(pv,EMPTY_VALUE);
  ArrayInitialize(fv,EMPTY_VALUE);  
  ArrayInitialize(FFT_Up,EMPTY_VALUE);
  ArrayInitialize(FFT_Down,EMPTY_VALUE);
//Choose indicator and find the average of its np past values
   double x[]; //stores indicator values
   ArrayResize(x,np);
   double av=0.0;
   for(int i=-lb;i<np;i++)
   {

   if( IndiName=="Ehlers"){
 in[i+lb]=0.5+iCustom(NULL,0,"Ehlers Two Pole Super Smoother Filter",Period_Indi,0,i+lb)/100.0;
 }
else  if( IndiName=="McGinley"){
 in[i+lb]=0.5+iCustom(NULL,0,"McGinley Dynamic main",Period_Indi,McGinley_Price,0,i+lb)/100.0;
 }
  else {
  Alert("Attention please!Type in the name exactly as shown in the Comment2!!!");
  
  }

  IndicatorShortName(WindowExpertName()+"("+IndiName+")"); 

     
      if(i>=0)
      {
         x[i]=in[i+lb];
         av+=x[i];
      }
   }
   av/=np;
   
//Prepare modeled data
   for(i=0;i<np;i++)
   {
      pv[i]=av;
      if(i<=nf) fv[i]=av;
   }

//Fit trigomometric series
   double w,m,c,s;
   for(int harm=1;harm<=HarmNo;harm++)
   {
      Freq(x,w,m,c,s);
      for(i=0;i<np;i++) 
      {
         pv[i]+=m+c*MathCos(w*i)+s*MathSin(w*i);
         if(i<=nf) fv[i]+=m+c*MathCos(w*i)-s*MathSin(w*i);
      }       
   }
   
//Reorder the predicted vector
   for(i=0;i<=(nf-1)/2;i++)
   {
      double tmp=fv[i];
      fv[i]=fv[nf-i];
      fv[nf-i]=tmp;
   } 
 
 for(i=limit; i>=0; i--)
{      
    

      if(pv[i]>pv[i+1]  )
      {
           FFT_Up[i]=pv[i];
           FFT_Up[i+1]=pv[i+1];
           trend=1;
           }
          
         
      
       if(pv[i]<pv[i+1]  )
      {
           FFT_Down[i]=pv[i];
           FFT_Down[i+1]=pv[i+1];
             trend =-1;
           }
         
      if (i>0){
         if ( trend >0 && LastSignal!=BUY){
           LastSignal=BUY;
          if (Draw_Line ){
          DrawLine(i, "Up");
          }
            if (Draw_Arrow  ){
         DrawArrow(i,"Up" );
         }
          if  (AlertOn  && i==1 && !TurnedDown )
           { 
           Alert("FFT is changing UP on"+" "+Symbol()," ",Period()+" "+"minute charts");
            TurnedUp = false;
            TurnedDown = true;
     }
           }
           }
            if (i>0){
            if ( trend <0 && LastSignal!=SELL){
           LastSignal=SELL;
          if (Draw_Line ){
          DrawLine(i, "Down");
          }
            if (Draw_Arrow  ){
         DrawArrow(i,"Down" );
         }
          if  (AlertOn  && i==1 && !TurnedDown )
           { 
           Alert("FFT is changing DOWN on"+" "+Symbol()," ",Period()+" "+"minute charts");
            TurnedUp = false;
            TurnedDown = true;
     }
           }    
      } 
     }
      if (i> limit2) 
   limit2= i;
   return(0);
}
 
     
//+--------------------------------------------------------------------------------------+
//Quinn and Fernandes algorithm
void Freq(double x[], double& w, double& m, double& c, double& s)
{
   double z[],num,den;
   ArrayResize(z,np);
   double a=0.0;
   double b=2.0;
   z[0]=x[0]-pv[0];
   while(MathAbs(a-b)>FreqTOL)
   {
      a=b;
      z[1]=x[1]-pv[1]+a*z[0];
      num=z[0]*z[1];
      den=z[0]*z[0];
      for(int i=2;i<np;i++)
      {
         z[i]=x[i]-pv[i]+a*z[i-1]-z[i-2];
         num+=z[i-1]*(z[i]+z[i-2]);
         den+=z[i-1]*z[i-1];
      }
      b=num/den;
   }
    w=MathArccos(MathMax(MathMin(b/2.0,1),-1)); //mladen correction
  // w=MathArccos(b/2.0);
   Fit(x,w,m,c,s);
   return;
}
//+-------------------------------------------------------------------------+
void Fit(double x[], double w, double& m, double& c, double& s)
{
   double Sc=0.0;
   double Ss=0.0;
   double Scc=0.0;
   double Sss=0.0;
   double Scs=0.0;
   double Sx=0.0;
   double Sxc=0.0;
   double Sxs=0.0;
   for(int i=0;i<np;i++)
   {
      double cos=MathCos(w*i);
      double sin=MathSin(w*i);
      Sc+=cos;
      Ss+=sin;
      Scc+=cos*cos;
      Sss+=sin*sin;
      Scs+=cos*sin;
      Sx+=(x[i]-pv[i]);
      Sxc+=(x[i]-pv[i])*cos;
      Sxs+=(x[i]-pv[i])*sin;
   }
   Sc/=np;
   Ss/=np;
   Scc/=np;
   Sss/=np;
   Scs/=np;
   Sx/=np;
   Sxc/=np;
   Sxs/=np;
   if(w==0.0)
   {
      m=Sx;
      c=0.0;
      s=0.0;
   }
   else
   {
      //calculating c, s, and m
      double den=MathPow(Scs-Sc*Ss,2)-(Scc-Sc*Sc)*(Sss-Ss*Ss);
      c=((Sxs-Sx*Ss)*(Scs-Sc*Ss)-(Sxc-Sx*Sc)*(Sss-Ss*Ss))/den;
      s=((Sxc-Sx*Sc)*(Scs-Sc*Ss)-(Sxs-Sx*Ss)*(Scc-Sc*Sc))/den;
      m=Sx-c*Sc-s*Ss;
   }
   return;
}
///////////////////////////////////////////////
//            DrawLineFunction              //
/////////////////////////////////////////////
void DrawLine(int i,string type)
{    
      count++;
      string name = StringConcatenate(SignalName,count);
      ObjectCreate(name,OBJ_VLINE,0,Time[i],1);
      if (type=="Up")
         {
           
          ObjectSet(name, OBJPROP_WIDTH, WidthLine);
         ObjectSet(name, OBJPROP_COLOR, colorup);
         }
      else if (type=="Down")
         {
            ObjectSet(name, OBJPROP_WIDTH, WidthLine);
         ObjectSet(name, OBJPROP_COLOR, colordown);
         }
         }
         ///////////////////////////////////////////////
//             DeleteFunction               //
/////////////////////////////////////////////

void DeleteObjects(){

 for (count = 0; count < ObjectsTotal(); count++) {
      if ((StringFind(ObjectName(count),SignalName) == 0)) {
         ObjectDelete(ObjectName(count));
         WindowRedraw();
        count--;
       }
         }
         }
 ///////////////////////////////////////////////
//            DrawArrowFunction             //
/////////////////////////////////////////////
void DrawArrow(int i,string type)
{     count++;
      string name2 = StringConcatenate(SignalName,count);
     ObjectCreate(name2,OBJ_ARROW,0,Time[i],0);
      if (type=="Up")
         {
            ObjectSet(name2,OBJPROP_PRICE1,Low[i]-(DistanceUp*Point));
            ObjectSet(name2,OBJPROP_ARROWCODE,233);
            ObjectSet(name2,OBJPROP_COLOR,colorup);
            ObjectSet(name2,OBJPROP_WIDTH,WidthArrow);
         }
      else if (type=="Down")
         {
            ObjectSet(name2,OBJPROP_PRICE1,High[i]+(DistanceDown*Point));
            ObjectSet(name2,OBJPROP_ARROWCODE,234);
             ObjectSet(name2,OBJPROP_WIDTH,WidthArrow);
            ObjectSet(name2,OBJPROP_COLOR,colordown);
        }
        
        }